import { JobDetails } from "../../../components/Job/JobDetails";
import { AppHarness } from "../../../mocks/AppHarness";
import jobs from "../../../mocks/fixtures/Jobs.json";

const STATUS_OPTIONS = ["SUCCESSFUL", "FAILED", "QUEUED", "RUNNING", "UNKNOWN"];
const OPERATION_TYPE_OPTIONS = [
  "DEPLOY",
  "UNDEPLOY",
  "BATCH_DEPLOY",
  "BATCH_UNDEPLOY",
  "START",
  "STOP"
];

export default {
  title: "Views/Job/JobDetailsView",
  argTypes: {
    operationType: {
      options: OPERATION_TYPE_OPTIONS,
      control: { type: "radio" }
    },
    status: {
      options: STATUS_OPTIONS,
      control: { type: "radio" }
    }
  }
};

const Template = (args) => {
  const currentJob = jobs.operations.find(
    (job) => job.type === args.operationType
  );
  return (
    <AppHarness>
      <JobDetails
        operation={Object.assign({}, currentJob, {
          type: args.operationType,
          status: args.status
        })}
        job={args.operation}
      />
    </AppHarness>
  );
};

export const Default = (args) => <Template {...args} />;

Default.args = {
  operationType: OPERATION_TYPE_OPTIONS[0],
  status: STATUS_OPTIONS[0]
};
